<!-- template="mla-overview" -->
<!-- title="Overview" order="1" -->
<p>The Known File Extension/MIME Type Associations list lets you add "Upload MIME Type" entries from over 1,500 existing association pairs. There can be several different MIME Type values for a given file extension. For example, the ".dif" extension is a video format and also a data interchange format (try it). </p>
<p>All the File Extension/MIME Type Associations are listed in the table, ordered by the file extension field. You can change the sort order by clicking on one of the blue column names.</p>
<p>You can use the Screen Options tab to choose how many items appear on each page of the display.</p>
<p>You can narrow the list by entering a keyword or phrase in the text box in the upper-right corner and clicking "Search Types". <strong>NOTE:</strong> The "Search Types" filter is &#8220;sticky&#8221;, i.e., it will persist as you resort the display, edit items, etc. To clear it, delete the text and click "Search Types".</p>
<p>If your search keyword begins with a dot ("."), e.g., ".dif", the search will be limited to the Extension values. For any other keyword or phrase, the search will include all of the column values.</p>
<!-- template="mla-types" -->
<!-- title="The Type Columns" order="2" -->
<p>The three MIME Type columns show where the extension/MIME Type associations come from:</p>
<ul>
<li><strong>MIME</strong>: All of the known types associated with this file extension.</li>
<li><strong>WordPress</strong>: WordPress defines a core set of extensions and associated MIME types, and this list changes with new WordPress releases. These are the "official" items.</li>
<li><strong>MLA</strong>: Media Library Assistant adds several more extension/type items, drawing from the most popular items found in other plugins and web sites.</li>
</ul>
<p>The "WordPress" and "MLA" values will often be blank. Where there are multiple MIME values for a given extension, the "WordPress" and "MLA" values will be the same.</p>
<!-- template="mla-bulk-actions" -->
<!-- title="Bulk Selection" order="3" -->
<p>The &#8220;Bulk Actions&#8221; dropdown list works with the check box column to let you select many items at once. Click the check box in the column title row to select all items on the page, or click the check box in a row to select items individually.</p>
<p>Once you&#8217;ve selected the items you want, pick an action from the dropdown list and click Apply to perform the action on the selected items.</p>
<!-- template="mla-available-actions" -->
<!-- title="Individual Selection" order="4" -->
<p>Hovering over a row in the Extension column reveals action links such as Select. Clicking "Select" will copy the extension, MIME Type and Description values in that row to the Uploads list, creating a new custom item or converting an existing core/mla item to custom with the new values.</p>
<!-- template="sidebar" -->
<p><strong>For more information:</strong></p>
<p><a href="[+settingsURL+]?page=mla-settings-menu-documentation&mla_tab=documentation#mla_optional_uploads" target="_blank">Documentation on Searching for Upload MIME Types</a></p>
<p><a href="http://wordpress.org/support/plugin/media-library-assistant" target="_blank">Support Forum</a></p>
